bento.define("entities/minigames/groupycat/groupycat",["bento","bento/math/vector2","bento/math/rectangle","bento/components/sprite","components/clickable","bento/entity","bento/eventsystem","bento/gui/clickbutton","bento/gui/counter","bento/gui/text","bento/utils","bento/tween","entities/minigames/groupycat/hand","entities/gestures/taphand"],function(e,n,t,o,i,a,s,c,m,p,r,d,u,l){"use strict";return function(t){var i=e.getViewport(),c=e.assets.getJson("groupycat"),m=c.difficulty[r.MiniGameManager.speed]||c.difficulty.max,f=m.timeToComplete||480,g=m.timePadding||40,h=m.handTime||45,w=m.handCount||7,y=m.handDelay||0,b=new n(i.width/2,i.height/2),v="groupycat/",x=!0,A=[],N={BACKGROUND:0,CAT:1,PEDESTAL:2,CUSHION:3,HAND:4,TUTORIAL:10},R=new a({z:N.BACKGROUND,position:b.clone(),originRelative:new n(.5,.5),components:[new o({imageName:v+"background"})]}),M=new a({name:"eyeLeft",position:new n(-20,-54),originRelative:new n(.5,.5),components:[new o({imageName:v+"eye"})]}),T=new a({name:"eyeRight",position:new n(3,-55),originRelative:new n(.5,.5),components:[new o({imageName:v+"eye"})]}),C={name:"lookAtClosestHand",leftPos:M.position.clone(),rightPos:T.position.clone(),movingHand:null,start:function(){s.on(r.Events.HAND_MOVE,C.updateHand)},destroy:function(){s.off(r.Events.HAND_MOVE,C.updateHand)},updateHand:function(e){C.movingHand=e},update:function(){var e,t;C.movingHand&&(e=C.movingHand.position.subtract(S.position.add(new n(-10,-55))),t=Math.atan2(e.y,e.x),M.position.x=C.leftPos.x+3*Math.cos(t),M.position.y=C.leftPos.y+2*Math.sin(t),T.position.x=C.rightPos.x+3*Math.cos(t),T.position.y=C.rightPos.y+2*Math.sin(t))}},H=new a({name:"eyesBack",position:new n(0,0),originRelative:new n(.5,.9),components:[new o({imageName:v+"eyesback"}),M,T,C]}),S=new a({z:N.CAT,name:"cat",position:b.add(new n(0,60)),originRelative:new n(.5,.9),components:[H,new o({imageName:v+"cat",frameCountX:3,frameCountY:2,padding:1,animations:{"default":{frames:[0]},sleep:{speed:.2,loop:!1,backTo:3,frames:[1,2,3,4]},touched:{frames:[5]}}}),{name:"bounceBehavior",update:function(e){S.scale.x=1+.025*Math.sin(S.timer/12),S.scale.y=1-.025*Math.sin(S.timer/12)}}]}),E=new a({z:N.PEDESTAL,name:"pedestal",position:S.position.add(new n(0,0)),originRelative:new n(.5,0),components:[new o({imageName:v+"pedestal"})]}),P=new a({z:N.CUSHION,name:"cushion",position:E.position.clone(),originRelative:new n(.5,.5),components:[new o({imageName:v+"cushion"})]}),k=new p({z:N.TUTORIAL,position:new n(b.x-29,48),text:r.Localization.getText("instructions").groupycat,fontSettings:r.FontSettings.get("font").tutorial,font:"font",fontSize:28,fontColor:"#ffffff",align:"center",textBaseline:"middle",lineWidth:2,strokeStyle:"#000000",innerStroke:!1,pixelStroke:!0,"float":!0,maxWidth:120,maxHeight:40}),z=new l({z:N.TUTORIAL,position:new n(b.x+64,100)}),D=function(){x&&(x=!1,s.dispatch(r.Events.GAME_WIN,{delay:120}),S.getComponent("sprite",function(n){var t=!1;n.setAnimation("sleep",function(){t||(e.audio.playSound(v+"sfx_sleep"),t=!0)})}),S.removeByName("eyesBack"),e.audio.playSound(v+"sfx_success"))},I=function(){if(x){var n;for(x=!1,s.dispatch(r.Events.GAME_LOSE,{delay:120}),n=0;w>n;n++)A[n].disable();S.getComponent("sprite",function(e){e.setAnimation("touched")}),r.timeout(20,function(){e.audio.playSound(v+"sfx_angry")}),new d({"in":120,ease:d.LINEAR,ignoreGameSpeed:!0,onUpdate:function(e,n){n%1===0&&(S.transform.x=r.getRandomRangeFloat(-1,1),S.transform.y=r.getRandomRangeFloat(-1,1))}}),S.removeByName("bounceBehavior"),S.scale.x=1,S.scale.y=1,e.audio.playSound(v+"sfx_fail")}},L=function(){1===k.alpha&&new d({from:1,to:0,"in":20,ease:d.LINEAR,onUpdate:function(e,n){k.alpha=e,z.alpha=e},onComplete:function(){}})},O=function(){var t,o,i=[],a=[],s=-(.15+.1*Math.random())*Math.PI,c=S.position.add(new n(0,-30));for(a[0]=0,t=1;w>t;t++)a[t]=a[t-1]+3+3*Math.random();for(t=0;w>t;t++)a[t]/=a[w-1],a[t]*=f-g-h,a[t]+=g/2;for(i[0]=0,t=1;w>t;t++)i[t]=i[t-1]+3+2*Math.random();for(t=0;w>t;t++)i[t]/=i[w-1],i[t]*=Math.PI*-.6,i[t]+=s;for(r.shuffle(i),t=0;w>t;t++)o=new u({z:N.HAND,assetPath:v,position:c,angle:i[t],delay:a[t],duration:h,onPet:I,handDelay:y}),e.objects.attach(o),A.push(o)},U={name:"behaviorComponent",start:function(n){e.objects.attach(R),e.objects.attach(S),e.objects.attach(P),e.objects.attach(E),e.objects.attach(k),e.objects.attach(z),O(),r.timeout(60+g,function(){L()})},update:function(e){k.position.y=60+4*Math.sin(B.timer/16)}},B=new a({z:0,name:"groupycat",position:t.position||new n(0,0),originRelative:new n(0,0),updateWhenPaused:0,components:[U]}).extend({timeToComplete:m.timeToComplete||500,onTimeUp:D,startTimerPaused:!1,startTimerHidden:!1});return B}});