bento.define("entities/minigames/matchcat/matchcat",["bento","bento/math/vector2","bento/math/rectangle","bento/components/sprite","components/clickable","bento/entity","bento/eventsystem","bento/gui/clickbutton","bento/gui/counter","bento/gui/text","bento/utils","bento/tween","entities/gestures/swipehand","entities/minigames/matchcat/endanimation"],function(n,e,t,i,o,a,s,c,r,p,m,l,f,u){"use strict";var h=4;return function(t){var c=n.getViewport(),r=n.assets.getJson("matchcat"),d=r.difficulty[m.MiniGameManager.speed]||r.difficulty.max,w=new e(c.width/2,c.height/2),g="matchcat/",x=d.correctStarts||0,b=d.typeVariety||3,E=!0,v=null,y=-1,N=new e(0,0),R=new e(0,0),T=[],S=[],A=[],I=0,U={BACKGROUND:0,ITEMS:3,LINES:6,OVERLAY:7,PRINTER:8,ENDANIMATION:9,TUTORIAL:10},M=new a({z:U.BACKGROUND,position:w.clone(),originRelative:new e(.5,.5),components:[new i({imageName:g+"background"})]}),z=new a({z:U.LINES,name:"swipeline",position:new e(w.x,145),originRelative:new e(.5,0),components:[new i({imageName:g+"swipeline"})]}),O=new a({z:U.LINES,name:"swipeline",position:new e(w.x,204),originRelative:new e(.5,0),components:[new i({imageName:g+"swipeline"})]}),C=new a({z:U.OVERLAY,name:"border",position:new e(w.x,w.y),originRelative:new e(.5,.5),components:[new i({imageName:g+"border"})]}),L=new p({z:U.TUTORIAL,position:new e(w.x,48),text:m.Localization.getText("instructions").matchcat,fontSettings:m.FontSettings.get("font").tutorial,font:"font",fontSize:20,fontColor:"#ffffff",align:"center",textBaseline:"middle",lineWidth:2,strokeStyle:"#000000",innerStroke:!1,pixelStroke:!0,"float":!0,maxWidth:160}),k=new f({z:U.TUTORIAL,position:new e(w.x,c.height-32)}),j=function(){E&&(E=!1,s.dispatch(m.Events.GAME_WIN,{delay:150}),P(!0),n.audio.playSound(g+"sfx_success"))},_=function(){E&&(D(),E=!1,P(!1),s.dispatch(m.Events.GAME_LOSE,{delay:150}),n.audio.playSound(g+"sfx_fail"))},P=function(t){var o,s=[];for(o=0;o<A.length;o++)m.forEach(A[o].items,function(n,e,t,i){Math.floor(e/2)!==T[o]?new l({from:1,to:0,"in":30,ease:l.LINEAR,onUpdate:function(e,t){n.alpha=e}}):o===s.length&&s.push(n.getComponent("sprite").animations["default"].frames[0])});var c=new a({z:U.PRINTER,name:"printicon",position:new e(w.x,48),originRelative:new e(.5,.5),scale:new e(0,0),components:[new i({imageName:g+"printicon"})]}),r=new a({z:U.PRINTER,name:"printfill",position:new e(0,0),originRelative:new e(0,.5),scale:new e(0,1),components:[new i({imageName:g+"printfill"})]}),p=new a({z:U.PRINTER,name:"printbar",position:new e(w.x,82),originRelative:new e(.5,.5),components:[r,new i({imageName:g+"printbar"})]});r.position.x=-p.dimension.width/2+1;var f=(p.dimension.width-2)/r.dimension.width;new l({from:0,to:1,"in":16,delay:10,ease:l.EASEOUTBACK,onStart:function(){n.objects.attach(c),n.objects.attach(p),n.audio.playSound(g+"sfx_printicon")},onUpdate:function(n,e){c.scale.x=n,p.scale.x=n}}),new l({from:0,to:1,"in":16,delay:14,ease:l.EASEOUTBACK,onUpdate:function(n,e){c.scale.y=n,p.scale.y=n}}),new l({from:0,to:1,"in":40,ease:l.LINEAR,onUpdate:function(n,e){r.scale.x=n*f},onComplete:function(){var e=new u({assetPath:g,z:U.ENDANIMATION,position:w.clone(),hasWon:t,usedParts:s});n.objects.attach(e)}})},D=function(){1===L.alpha&&new l({from:1,to:0,"in":20,ease:l.LINEAR,onUpdate:function(n,e){L.alpha=n,k.alpha=n}})},B=function(){var t,o,s,c,r,p=[],l=[];for(t=0;h>t;t++)l.push(t+1);m.shuffle(l),l.unshift(0),l.length=b;var f=["ears","heads","butts"],u=[0,66,118],d=[];for(t=0;3>t;t++)x>t?d[t]=0:d[t]=l[Math.ceil(Math.random()*(b-1))];for(m.shuffle(d),t=0;3>t;t++){do p=m.shuffle(l,!0);while(p[0]!==d[t]);A[t]={};var E=new a({z:U.ITEMS,name:"container",position:new e(w.x,110+u[t])});for(n.objects.attach(E),A[t].container=E,A[t].items=[],T[t]=0,o=0;o<p.length;o++){for(s=0;2>s;s++)r=new e(0,0),r.x=120*o-s*(120*l.length),2===t&&(r.x-=4),c=new a({z:U.ITEMS,name:"item",position:r,originRelative:new e(.5,.5),components:[new i({imageName:g+f[t],frameCountX:3,frameCountY:2,padding:1,animations:{"default":{speed:0,frames:[p[o]]}}})]}),A[t].container.attach(c),A[t].items.push(c),A[t].height=c.dimension.height;0===p[o]&&(S[t]=o)}}},G=function(e){var t,i,o=e.items.length/2*120;for(t=0;t<e.items.length;t++)i=e.items[t],i.position.x+e.container.position.x<-o+I&&(i.position.x+=2*o,m.TapticEngine.impact({style:"light"}),n.audio.stopSound(g+"sfx_click"),n.audio.playSound(g+"sfx_click")),i.position.x+e.container.position.x>o+I&&(i.position.x-=2*o,m.TapticEngine.impact({style:"light"}),n.audio.stopSound(g+"sfx_click"),n.audio.playSound(g+"sfx_click"))},W=function(e){var t=w.x,i=e.container.position.x,o=m.modulo(i-w.x,120)-60;t=0>o?i-(60+o):i+(60-o),new l({from:i,to:t,"in":20,ease:l.EASEOUTQUAD,onUpdate:function(n,t){e.container.position.x=n}}),T[A.indexOf(e)]=Math.round(m.modulo((w.x-t)/120,e.items.length/2)),n.audio.playSound(g+"sfx_snap")},K=function(){var n;for(n=0;n<S.length;n++)if(S[n]!==T[n])return;j()},V=new o({pointerDown:function(n){if(E&&null===v){var e,t;for(v=n.id,y=-1,R=n.position,N=n.position,e=0;e<A.length;e++)if(t=Math.abs(A[e].container.position.y-n.position.y),t<A[e].height/2){y=e;break}}},pointerUp:function(n){E&&v===n.id&&(v=null,-1!==y&&(W(A[y]),K()),D())},pointerMove:function(n){if(E&&v===n.id&&-1!==y){var e=n.position.x-R.x;A[y].container.position.x+=e,R=n.position,I=0>e?10:-10,G(A[y])}}}),Y={name:"behaviorComponent",start:function(e){var t;for(n.objects.attach(M),n.objects.attach(z),n.objects.attach(O),n.objects.attach(C),n.objects.attach(L),n.objects.attach(k),B(),t=0;t<A.length;t++)if(T[t]!==S[t]){k.begin(),k.position.y=A[t].container.position.y+A[t].height/2+30;break}m.timeout(d.timeToComplete/2*e.speed,function(){D()})},destroy:function(n){},update:function(n){L.position.y=48+4*Math.sin(F.timer/16)},draw:function(n){}},F=new a({z:0,name:"matchcat",position:t.position||new e(0,0),originRelative:new e(0,0),updateWhenPaused:0,components:[Y,V]}).extend({timeToComplete:d.timeToComplete||500,onTimeUp:function(){-1!==y&&(W(A[y]),K()),_()},startTimerPaused:!1,startTimerHidden:!1});return F}});