bento.define("entities/minigames/recallyshape/recallyshape",["bento","bento/math/vector2","bento/math/rectangle","bento/components/sprite","components/clickable","bento/entity","bento/eventsystem","bento/gui/clickbutton","bento/gui/counter","bento/gui/text","bento/utils","bento/tween","entities/minigames/recallyshape/button"],function(e,t,n,o,a,i,s,c,r,p,m,u,l){"use strict";var f={BACKGROUND:1,SCREEN:2,CHAT:3,MESSAGE:5,BUTTON:8,PHONE:14,PREVIEW:15,TUTORIAL:20},d=["bone","paw"];return function(n){var a,c=e.getViewport(),r=new t(c.width/2,c.height/2),h=!1,w="recallyshape/",g=e.assets.getJson("recallyshape"),v=m.MiniGameManager.speed,y=g.timeToComplete[v]||g.timeToComplete.max,x=g.timeToLook[v]||g.timeToLook.max,E=g.gridSize[v]||g.gridSize.max,T=g.nonDefault[v]||g.nonDefault.max,b=g.sameColor[v]||g.sameColor.max,C=[],S=[],P=new i({name:"background",z:f.BACKGROUND,position:r.clone(),originRelative:new t(.5,.5),updateWhenPaused:0,components:[new o({imageName:w+"background"})]}),R=new i({name:"phoneContainer",z:f.PHONE,position:r.clone(),originRelative:new t(.5,.5),"float":!1,family:[""],updateWhenPaused:0,components:[]}),U={name:"handBehavior",upPos:new t(0,0),downPos:new t(0,0),start:function(){U.downPos=N.position.clone(),U.upPos=N.position.add(new t(5,-10)),N.rotation=.4},update:function(){N.timer%60===0?N.position=U.downPos:N.timer%60===30&&(N.position=U.upPos),(N.timer>200||h)&&(e.objects.remove(N),e.objects.remove(W))}},N=new i({z:f.TUTORIAL,name:"hand",position:new t(r.x+50,r.y-90),"float":!0,originRelative:new t(.5,.5),components:[new o({imageName:"gestures/hand"}),U]}),A=new p({z:f.TUTORIAL,position:new t(0,-90),text:m.Localization.getText("instructions").recallyshape[0],fontSettings:m.FontSettings.get("font").tutorial,fontSize:16,maxWidth:100,fontColor:"#ffffff",lineWidth:1,strokeStyle:"#000000",pixelStroke:!0,align:"center",textBaseline:"middle"}).attach(new i({name:"curvedarrow",z:0,position:new t(-270,100),originRelative:new t(0,0),"float":!1,family:[""],updateWhenPaused:0,scale:new t(1,-1),components:[new o({imageName:w+"curvedarrow"})]})).attach(new i({name:"curvedarrow",z:0,position:new t(270,100),originRelative:new t(0,0),"float":!1,family:[""],updateWhenPaused:0,scale:new t(-1,-1),components:[new o({imageName:w+"curvedarrow"})]})).attach({update:function(e){A.rotation=Math.PI/30*Math.sin(A.timer/20)}}),W=new p({z:f.TUTORIAL,position:new t(r.x-20,r.y-90),text:m.Localization.getText("instructions").recallyshape[1],fontSettings:m.FontSettings.get("font").tutorial,fontSize:16,maxWidth:100,fontColor:"#ffffff",lineWidth:1,strokeStyle:"#000000",pixelStroke:!0,align:"center",textBaseline:"middle"}).attach({update:function(e){W.rotation=Math.PI/12*Math.sin(W.timer/20)}}),k={name:"behavior",start:function(e){s.on(m.Events.PRESSED_BUTTON,j)},destroy:function(e){s.off(m.Events.PRESSED_BUTTON,j)},update:function(e){}},O=new i({z:0,name:"recallyshape",updateWhenPaused:0,components:[k]}),z=function(){if(!h){var t={delay:120};h=!0,I(!1),e.audio.playSound(w+"sfx_fail"),s.dispatch(m.Events.GAME_LOSE,t)}},B=function(){if(!h){var t={delay:120};h=!0,I(!0),e.audio.playSound(w+"sfx_success"),s.dispatch(m.Events.GAME_WIN,t)}},I=function(n){var s=0,p=0,l=15,d=new i({name:"lock",z:f.BUTTON,position:r.clone(),originRelative:new t(.5,.5),"float":!1,family:[""],updateWhenPaused:0,components:[new o({imageName:w+"lock",frameCountX:2,frameCountY:1,animations:{locked:{frames:[0]},unlocked:{frames:[1]},unlock:{frames:[0,1],speed:.05,loop:!1}}})]}),h=new i({name:"chat",z:f.CHAT,position:r.clone(),originRelative:new t(.5,.5),"float":!1,family:[""],updateWhenPaused:0,components:[new o({imageName:w+"chatscreen"})]});new u({from:1,to:0,"in":l,ease:u.EASEOUTCUBIC,updateWhenPaused:0,onUpdate:function(e,t){for(s=0,p=C.length;p>s;++s)C[s].alpha=e}}),n||a.getComponent("sprite").setup({imageName:w+"red"}),m.timeout(l,function(){e.objects.attach(d),n?(e.audio.playSound(w+"sfx_lockwin"),d.getComponent("sprite").setAnimation("unlock",function(){d.getComponent("sprite").setAnimation("unlocked"),e.objects.attach(h),new u({from:1,to:0,"in":10,ease:u.EASEOUTCUBIC,updateWhenPaused:0,onUpdate:function(e,t){d.alpha=e}}),new u({from:a.position.y,to:a.position.y+2*c.height,"in":30,ease:u.EASEOUTCUBIC,updateWhenPaused:0,onUpdate:function(e,t){a.position.y=e,h.position.y=e/4}})})):(e.audio.playSound(w+"sfx_locklose"),m.TapticEngine.impact({style:"medium"}),new u({from:0,to:1,"in":60,ease:u.LINEAR,updateWhenPaused:0,onUpdate:function(e,t){d.alpha=e}}))})},j=function(){var e=0,t=0;for(e=0,t=C.length;t>e;++e)if(C[e].getState()!==S[e])return;B()},L=function(){var e=0,t=0,n=[];for(e=0,t=T;t>e;++e)n.push(d[1]);for(e=0,t=E.x*E.y-T;t>e;++e)n.push(d[0]);return n},M=function(){var n,a=0,s=0,c=0,p=0,u=-1,l=40,h=-(l*(E.x-1)/2),g=-(l*(E.y-1)/2)+20,v=new i({name:"previewContainer",z:f.PREVIEW,position:r.clone(),originRelative:new t(.5,.5),components:[]});for(a=0,s=E.x;s>a;++a)for(c=0,p=E.y;p>c;++c)++u,n=new i({name:"previewButton",position:new t(h+l*a,g+l*c),originRelative:new t(.5,.5),components:[new o({imageName:w+"button",frameCountX:2,frameCountY:1,animations:{"default":{frames:[d.indexOf(S[u])]}}})]}),v.attach(n);e.objects.attach(v),v.attach(A),H(),m.timeout(x,function(){_(v),G()})},_=function(t){var n=0,o=0,a=30;for(n=0,o=t.components.length;o>n;++n)new u({from:1,to:0,"in":a,ease:u.EASEOUTCUBIC,updateWhenPaused:0,id:n,onUpdate:function(e,n){t.components[this.id].alpha=e}});m.timeout(a,function(){e.objects.remove(t)})},D=function(){var n,o=0,a=0,i=0,s=0,c=40,p=-(c*(E.x-1)/2),u=-(c*(E.y-1)/2)+20;for(o=0,a=E.x;a>o;++o)for(i=0,s=E.y;s>i;++i)n=new l({index:o+""+i,Layers:f,States:d,state:b?d[0]:d[m.getRandom(d.length)],position:r.add(new t(p+c*o,u+c*i))}),n.visible=!1,C.push(n),e.objects.attach(n)},G=function(){var t=0,n=0,o=[],i=W.position.x,r=N.position.x;for(t=0,n=C.length;n>t;++t)C[t].setActive(!0),o.push(C[t].position.x),C[t].visible=!0;e.objects.attach(W),e.objects.attach(N),a.getComponent("sprite").setup({imageName:w+"blue"}),new u({from:1,to:0,"in":30,ease:u.EASEOUTCUBIC,updateWhenPaused:0,onUpdate:function(e,o){for(t=0,n=C.length;n>t;++t)C[t].alpha=1-e;W.position.x=i+c.width*e,N.position.x=r+c.width*e},onComplete:function(){s.dispatch(m.Events.START_TIMER)}})},H=function(){var n=new i({name:"phone",position:new t(0,0),originRelative:new t(.5,.5),"float":!1,family:[""],updateWhenPaused:0,components:[new o({imageName:w+"phone"})]});a=new i({name:"phoneBg",z:f.SCREEN,position:new t(0,0),originRelative:new t(.5,.5),components:[new o({imageName:w+"white"})]}),a.scale.x*=c.width,a.scale.y*=c.height,e.objects.attach(a),R.attach(n),e.objects.attach(R)};return function(){var e=0,t=0,n=L();for(e=0,t=n.length;t>e;++e)S.push(n.splice(m.getRandom(n.length),1)[0])}(),e.objects.attach(P),P.scale.x*=c.width,P.scale.y*=c.height,M(),D(),O.extend({startTimerPaused:!0,timeToComplete:y,onTimeUp:function(){var e=0,t=0;for(e=0,t=C.length;t>e;++e)C[e].setActive(!1);z()}}),O}});